# -*- coding: iso-8859-1 -*-
import numpy as np


from  MeshUtils    import *


class Node:

    id=int(-1)
    x=float(np.nan)
    y=float(np.nan)
    z=float(np.nan)


    def _init_(self, id_=None):
        if id_ == None:
           self.id=int(-1)
        else:
           self.id=toint(id_)

    def getX(self):
        if np.isnan( self.x):
           print 'Warning: coordinate x is NaN. Id: ' + str(self.id)
        return  self.x


    def getY(self):
        if np.isnan( self.y):
           print 'Warning: coordinate y is NaN. Id: ' + str(self.id)
        return  self.y

    def getZ(self):
        if np.isnan( self.z):
           print 'Warning: coordinate z y is NaN. Id: ' + str(self.id)
        return  self.z

    def getCoordinates(self):
        if np.isnan(self.x) or np.isnan(self.y) or np.isnan(self.z):
           print 'Warning: a coordinate is NaN. Id: ' + str(self.id)
        return  np.array([self.x , self.y , self.z])

    def setX(self,x_):
        self.x=tofloat(x_)

    def setY(self,y_):
        self.y=tofloat(y_)

    def setZ(self,z_):
        self.z=tofloat(z_)

    def isInitialized(self):
        if  np.isnan( self.x)  and \
            np.isnan( self.y)  and \
            np.isnan( self.z)  :
              return False
        else:
              return True

    def hasId(self):
      if  self.id < 0:
          return False
      else:
          return True

    def Print(self):
        print 'id('+str(self.id)+'):[ '+str(self.x)+' '+str(self.y)+' '+str(self.z)+']'


#Overload  +,-

    def __add__(self,other):   # self+other
        try:
            if self.isInitialized() and other.isInitialized():
                x=self.x + other.x;
                y=self.y + other.y;
                z=self.z + other.z;
                add=Node()
                add.x=x; add.y=y ; add.z=z
                return add
            else:
                print  'Error: in Node.+ node(s) not initialized'
                exit(1)
        except:
                print  'Error: in Node.+ param is not Node'
                exit(1)

    def __sub__(self,other):   # self-other
        try:
            if self.isInitialized() and other.isInitialized():
                x=self.x - other.x;
                y=self.y - other.y;
                z=self.z - other.z;
                sub=Node()
                sub.x=x; sub.y=y ; sub.z=z
                return sub
            else:
                print  'Error: in Node.+ node(s) not initialized'
                exit(1)
        except:
                print  'Error: in Node.+ param is not Node'
                exit(1)
