# -*- coding: iso-8859-1 -*-
import numpy as np

from  MeshUtils  import *
from  T_dimensions import *

def genGeoT(casename):

   outFile=casename+'_ele1.geo'  
   fileWriter=open(outFile,'w+')

   fileWriter.write('// ELE1 **** \n')
   fileWriter.write('// ELE 1 : Points \n')
   fileWriter.write('// Points at V0 Ievel\n')

   id=1
   x=-H1; y=V0; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   id=2
   x=H1; y=V0; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
   
   fileWriter.write('// Points at V1 Ievel\n')
   
   id=3 
      
   x=-H4; y=V1 ; z=Z
      
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
   
   id=4
   x=-H2; y=V1 ; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   id=5
   x=-H1; y=V1 ; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
   
   id=6
   x=H1; y=V1; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   id=7
   x=H2; y=V1 ; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
   
   id=8
   x=H3; y=V1; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   fileWriter.write('// Points at V2 Ievel\n')
      
   id=9
      
   x=-H3; y=V2; z=Z      
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )    
   id=10
   x=-H2; y=V2; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   id=11
   x=-H1; y=V2; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   id=12
   x=H1; y=V2; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   id=13
   x=H2; y=V2; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
      
   id=14
   x=H4; y=V2; z=Z
   fileWriter.write(POINT3D.format( id_=str(id),x_=str(z),y_=str(x),z_=str(y)) )
     
   fileWriter.write('\n')
      
   fileWriter.write('// ELE 1 : Lines \n')
      
   fileWriter.write('// Lines at V0 leve|\n')
      
   id=1   
   p1=1;p2=2
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   fileWriter.write('// Lines between V0-V1 leve|s\n')

   id=2
   p1=1;p2=5
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   id=3
   p1=2;p2=6
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   fileWriter.write('// Lines at V1 Ieve|\n')

   id=4 
   p1=3;p2=4
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   id=5
   p1=4;p2=5
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   id=6
   p1=5;p2=6
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   id=7
   p1=6;p2=7
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   id=8
   p1=7;p2=8
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   fileWriter.write('// Lines between V1-V2 leve|s\n')

   id=9
   p1=3;p2=9   
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   id=10
   p1=4;p2=10
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   id=11
   p1=5;p2=11
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   id=12
   p1=6;p2=12
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
     
   id=13
   p1=7;p2=13
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   id=14
   p1=8;p2=14
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   fileWriter.write('// Lines at V2 Ievel\n')
      
   id=15     
   p1=9;p2=10      
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   id=16
   p1=10;p2=11
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
      
   id=17
   p1=11;p2=12
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))
   
   id=18
   p1=12;p2=13
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   id=19
   p1=13;p2=14
   fileWriter.write(LINE.format( id_=id,p1_=str(p1),p2_=str(p2) ))

   fileWriter.write('\n')
   
   fileWriter.write('// ELE 1 : Lines Loops l Surfaces\n')
   
   fileWriter.write('// Base\n')
   fileWriter.write('// Base 1\n')
   id=1
   
   list='1,3,-6,-2'
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='1'
   
   fileWriter.write(PSURF.format( id_=id,list_=list ))
   
   fileWriter.write('// Spacing L1 \n')
   
   lineList='1'   
   args=str(nL1)   
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
   
   fileWriter.write('// Spacing L2-L3\n')
   
   lineList='2,3'   
   progRate=0.90   
   args=str(nL2) +PROGRESSION+' '+str(progRate)
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
   
   fileWriter.write('// Spacing L6 \n')
   lineList='6'
   
   args=str(nL6)
   
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
   
   fileWriter.write('// Base 2 Top Midd|e\n')
   id=2   
   list='6,12,-17,-11'   
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='2'   
   fileWriter.write(PSURF.format( id_=id,list_=list ))
   
   fileWriter.write('// Spacing L11-L12\n')
   
   lineList='11,12'   
   args=str(nL11)   
   fileWriter.write(TRNSLINE.format( lineList_=lineList, args_=args ))
   
   fileWriter.write('// Spacing L17 \n')
   lineList='17'
   args=str(nL17)   
   fileWriter.write(TRNSLINE.format( lineList_=lineList, args_=args ))   
   
   fileWriter.write('//Base 3 inner Wing Left\n')
   id=3   
   list='5,11,-16,-10'   
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='3'   
   fileWriter.write(PSURF.format( id_=id,list_=list ))
   
   fileWriter.write('// Spacing L5-L16\n')
   
   lineList='5,16'      
   args=str(nL5)      
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))      
   fileWriter.write('//Spacing L10 \n')      
   lineList='10'      
   args=str(nL10)      
   fileWriter.write(TRNSLINE.format( lineList_=lineList, args_=args ))
      
   fileWriter.write('\n')
   fileWriter.write('// Base 4 inner Wing Right\n')
      
   id=4      
   list='7,13,-18,-12'      
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='4'      
   fileWriter.write(PSURF.format( id_=id,list_=list ))
   
   fileWriter.write('// Spacing L7-L18\n')
      
   LineList='7,18'
   args=str(nL7)
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
     
   fileWriter.write('// Spacing L13\n')
      
   lineList='13'
   args=str(nL13)
      
   fileWriter.write(TRNSLINE.format( lineList_=lineList, args_=args ))
   
   fileWriter.write('// Base 5 outher Wing Left\n')

   fileWriter.write('// Wing 5\n')

   id=5
   list='4,10,-15,-9'
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='5'

   fileWriter.write(PSURF.format( id_=id,list_=list ))
   
   fileWriter.write('// Spacing L4\n')
   lineList='4'   
   args=str(nL4)
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
      
   fileWriter.write('// Spacing L15\n')
      
   lineList='15'      
   args=str(nL15)      
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
      
   fileWriter.write('// Spacing L9 Contact\n')
      
   lineList='9'       
   args=str(nL9)         
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
         
   fileWriter.write('//Base 6 outher Wing Right\n')         
   fileWriter.write('//Wing 6\n')
         
   id=6         
   list='8,14,-19,-13'         
   fileWriter.write(LLOOP.format( id_=id,list_=list ))
   list='6'      
   fileWriter.write(PSURF.format( id_=id,list_=list ))
         
   fileWriter.write('// Spacing L19\n')
         
   lineList='19'      
   args=str(nL19)
      
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))      
   fileWriter.write('//Spacing L8\n')
   
   lineList='8'
   args=str(nL8)   
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
   
   fileWriter.write('//Spacing L14 Contact\n')
   
   lineList='14'   
   args=str(nL14)
   fileWriter.write(TRNSLINE.format( lineList_=lineList,args_=args ))
   
   
   
   
   fileWriter.write('\n\n// Extrude \n')
   surflist='{1,2,3,4,5,6}'
   fileWriter.write('Extrude{-8,0,0} { \n')
   fileWriter.write(' Surface'+surflist+';\n')
   fileWriter.write(' Layers{1};\n')
   fileWriter.write('}')
   
   
   
   fileWriter.close()