# -*- coding: iso-8859-1 -*-
import numpy as np


from  MeshUtils  import *


class ElementType:

      name='UNDEFINED'
      alternativename='UNDEFINED'
      nnodes=0
      dimension=0



#DICTIONARY
ElementTypes=dict();


#C3D8 brick 8 node
type_c3d8=ElementType()
type_c3d8.name='C3D8'
type_c3d8.alternativename='F3D8'
type_c3d8.dimension=3
type_c3d8.nnodes=8
ElementTypes['C3D8']= type_c3d8


#C3D4  Tetrahedra 4 nodes
type_c3d4=ElementType()
type_c3d4.name='C3D4'
type_c3d4.alternativename='F3D4'
type_c3d4.dimension=3
type_c3d4.nnodes=4
ElementTypes['C3D4']= type_c3d4

#C3D10 Tetrahedra 10 nodes(2 Order)
type_c3d10=ElementType()
type_c3d10.name='C3D10'
type_c3d10.alternativename='F3D10'
type_c3d10.dimension=3
type_c3d10.nnodes=4
ElementTypes['C3D10']= type_c3d10


class ElementList:
      type = 'UNDEFINED'
      nelements=0
      elements=list()

      def addElement(self, element):
            self.elements.append(element)



allElements=dict()

list_c3d10=ElementList()
list_c3d10.type='C3D10'
allElements['C3D10']=list_c3d10

list_c3d4=ElementList()
list_c3d4.type='C3D4'
allElements['C3D4']=list_c3d4
