import ConfigParser, os, sys, argparse, socket, errno,re
import numpy as np


from  Node         import *
from  Element      import *
from  MeshUtils    import *
from  NodeSet      import *

from  genMesh      import *

from  genT         import *
from  genWing      import *

import convertmesh  


import os.path

class eleFile:
    
    fileName=''
    outFile=''
    
    nodes=list()
    nodeSetName=''
    NodeSetDict=list()




    elements=list()
    eleSetname=''
    
    elements_c3d4=list()
    eleSetname_c3d4=''
    
    elements_c3d10=list()
    eleSetname_c3d10=''
    
    elements_s6=list()
    elemSetname_s6=''
    
    
    
    def __init__(self, fileName_):
        self.fileName=fileName_
        self.outFile=fileName_+'.inp'
        
    
    def convertMesh(self):
        MeshInfo=convertmesh.convertMesh(self.fileName, self.outFile)   
        
        self.nodes=MeshInfo['nodes:']
        
        self.nodeSetName='Nset_'+self.fileName
        
        self.elements_c3d4=MeshInfo['ele_c3d4:']
        self.eleSetname_c3d4='ELEc3d4_'+self.fileName
        
        self.elements_c3d10=MeshInfo['ele_c3d10:']
        self.eleSetname_c3d10='ELEc3d10_'+self.fileName
        
        self.elements_s6=MeshInfo['ele_s6:']
        self.eleSetname_s6='ELECs6_'+self.fileName
        
        self.NodeSetDict=MeshInfo['nodeSets:']
        
        
        
        
    